package com.myurbex.controllers;

import com.myurbex.models.User;
import com.myurbex.models.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.Optional;

@Controller	// This means that this class is a Controller
@RequestMapping(path="/user") // This means URL's start with /demo (after Application path)
public class UserController {
	@Autowired // This means to get the bean called userRepository
			   // Which is auto-generated by Spring, we will use it to handle the data
	private UserRepository userRepository;

	@PostMapping(path="/add") // Map ONLY POST Requests
	public @ResponseBody String addNewUser (@RequestParam String nickname
			, @RequestParam String email, @RequestParam String password, @RequestParam int user_type_id) {
		// @ResponseBody means the returned String is the response, not a view name
		// @RequestParam means it is a parameter from the GET or POST request

		User user = new User();
		user.setNickname(nickname);
		user.setEmail(email);
		user.setPassword(password);
		user.setUser_type_id(user_type_id);
		userRepository.save(user);
		return "Saved";
	}

	@GetMapping(path="/all")
	public @ResponseBody Iterable<User> getAllUsers() {
		// This returns a JSON or XML with the users
		return userRepository.findAll();
	}

	@GetMapping(path="/id")
	public @ResponseBody Optional<User> getUserById(@RequestParam int id) {
		// This returns a JSON or XML with the users
		return userRepository.findById(id);
	}

	@GetMapping(path="/email")
	public @ResponseBody Optional<User> getUserByEmail(@RequestParam String email) {
		// This returns a JSON or XML with the users
		return Optional.ofNullable(userRepository.findUserByEmail(email));
	}
}
